#! --------------------------------------------------------------------------
#! Processor Binder  2003 - 2006 R.S.F. Abspoel
#! --------------------------------------------------------------------------
#TEMPLATE (PB, 'Processor Binder'),FAMILY('ABC'),FAMILY('CW20')
#EXTENSION (PB, 'Processor Binder - Global Extension'), APPLICATION
#SHEET
#TAB ('Processor Binder')
#DISPLAY ('')
#DISPLAY ('This template allows you to set the affinity mask')
#DISPLAY ('of your application to a single CPU on')
#DISPLAY ('multi-cpu machines.')
#DISPLAY ('')
#BOXED (' Copyright and support ')
#DISPLAY ('')
#BUTTON (' License notice')
   #DISPLAY ('This template is freeware.')
   #DISPLAY ('Copyright  2006 by Roel S.F. Abspoel.')
   #DISPLAY ('')
   #DISPLAY ('You are authorised to copy, share or distribute this product')
   #DISPLAY ('in its origional form.')
   #DISPLAY ('Modification of any part(s) are forbidden.')
   #DISPLAY ('')
   #DISPLAY ('The following files are part of the origional package:')
   #DISPLAY ('ProcessorBinder.TPL')
   #DISPLAY ('Kernel32.LIB')
   #DISPLAY ('')
   #DISPLAY ('If your package contains different files please contact the author.')
   #DISPLAY ('For more information email the author. (roel.abspoel@gmail.com)')
#ENDBUTTON
#PROMPT ('I agree with the license notice.', CHECK), %LicenseAccepted, AT(10), DEFAULT(0)
#DISPLAY ('')
#DISPLAY ('Author: Roel S.F. Abspoel')
#DISPLAY ('Support: roel.abspoel@gmail.com')
#DISPLAY (' 2006 Roel S.F. Abspoel, All Rights Reserved.')
#ENDBOXED
#DISPLAY ('')
#ENABLE (%LicenseAccepted = %TRUE)
#DISPLAY ('')
#DISPLAY ('Call BindToCPU(<CPU Number>) to bind your application')
#DISPLAY ('BindToCPU() will return either of these values:')
#DISPLAY ('')
#DISPLAY ('0 - Process Affinity Mask Failed to set.')
#DISPLAY ('1 - Process Affinity Mask has been set.')
#DISPLAY ('2 - No action taken, single CPU machine.')
#DISPLAY ('3 - Incorrect processor nr.')
#DISPLAY ('')
#DISPLAY ('ProcessorCount() Will return the number of processors.')
#DISPLAY ('')
#PROMPT ('Include GetSystemInfo API', CHECK), %PBGSI, AT(10), DEFAULT(%true)
#PROMPT ('Include GetCurrentProcess API', CHECK), %PBGCP, AT(10), DEFAULT(%true)
#PROMPT ('Include SetProcessAffinityMask API', CHECK), %PBSPAM, AT(10), DEFAULT(%true)
#PROMPT ('Include ProcessorBinder.lib', CHECK), %PBLIB, AT(10), DEFAULT(%true)
#DISPLAY ('')
#BOXED (' Version information ')
#DISPLAY ('Version:    1.02')
#DISPLAY ('Changed: May 4 2006')
#ENDBOXED
#ENDENABLE
#ENDTAB
#ENDSHEET
#! --------------------------------------------------------------------------
#! Global Data
#! --------------------------------------------------------------------------
#AT (%GlobalMap)
  MODULE('KERNEL32')
    #IF (%PBSPAM = %True)
    SetProcessAffinityMask(UNSIGNED,LONG),LONG,PASCAL,RAW
    #ENDIF
    #IF (%PBGCP = %TRUE)
    GetCurrentProcess(),LONG,PASCAL,RAW
    #ENDIF
  END
  MODULE('SYSTEMINFO')
    #IF (%PBGSI = %TRUE)
    GetSystemInfo(*SYSTEM_INFO),PASCAL,RAW
    #ENDIF
  END
  PROCESSORCOUNT(),STRING
  BindToCPU(<LONG>),LONG
#ENDAT
#! --------------------------------------------------------------------------
#! Global Declarations
#! --------------------------------------------------------------------------
#AT(%CustomGlobalDeclarations)
  #IF (%PBLIB = %TRUE)
  #PROJECT('ProcessorBinder.lib')
  #ENDIF
#ENDAT
#! --------------------------------------------------------------------------
#! Procedures
#! --------------------------------------------------------------------------
#AT (%ProgramProcedures)

PROCESSORCOUNT           FUNCTION()
ENDPRO          CSTRING(15)
SYSTEM_INFO     GROUP,TYPE
dwOemId                     LONG
dwPageSize                  LONG
pMinimumApplicationAddress ULONG
lpMaximumApplicationAddress ULONG
dwActiveProcessorMask       LONG
dwNumberOfProcessors        LONG
dwProcessorType             LONG
dwAllocationGranularity     LONG
dwReserved                  LONG
wProcessorLevel		    USHORT
wProcessorRevision	    USHORT
wProcessorArchitecture      USHORT
              END
SystemInfo  LIKE(SYSTEM_INFO),AUTO
   CODE
#IF (%LicenseAccepted = %TRUE)
   GetSystemInfo(SystemInfo)
   RETURN(SystemInfo.dwNumberOfProcessors)
#ELSE
   ! The license was not accepted in the global extension
   RETURN()
#ENDIF


BindToCPU	FUNCTION(ProcessorNR)
ReturnString	LONG
RealProcessorNR	LONG
RetMessage	Cstring(255)
	CODE
#IF (%LicenseAccepted = %TRUE)
	IF ProcessorNR > 0
	  RealProcessorNR = ProcessorNR
	ELSE
	  RealProcessorNR = 1
	END
        IF PROCESSORCOUNT() > 1
          IF RealProcessorNR > PROCESSORCOUNT()
            ReturnString = 3
          ELSE
            ReturnString = SetProcessAffinityMask(GetCurrentProcess(),RealProcessorNR)
          END
        ELSE
          ReturnString = 2
        END
	RETURN(ReturnString)
#ELSE
        ! The license was not accepted in the global extension
        RETURN()
#ENDIF

#ENDAT